if isempty(who('redo')), redo=2; end;
if isempty(who('showresults')), showresults=1; end;

NN = 20*30*2;
DD = 3;
KK = 14;
FF = 2;
nn = 12;
dd = 2;

if redo>1,
  i = (1.5*pi/60:1.5*pi/30:1.5*pi)';
  x = [cos(i); sin(i)];
  y = [sin(i)+1; cos(i)-1]/2;
  n = 20;
  z = (0:1/(n-1):1)'*2-1;
  xx = [kron(x,ones(n,1)) kron(y,ones(n,1)) kron(ones(length(x),1),z)]';
  cc = kron(length(x):-1:1,ones(n,1))/length(x);
  xx = xx([1 3 2],:);
  XX = xx + .06*randn(3,n*length(x));
  xx = reshape(xx',[20 60 3]);
  clear x n y i z


  [LX,MX,PX,Pi]=mppca(XX,FF,KK,1e-10,200,1e-3);
  redo=1;
end;

if redo>0,
  [RR,ZZ] = infermfa(XX,LX,MX,PX,Pi);
  neighbor = knn(XX,nn);
  redo=0;
end;

[YY LY MY] = llc(XX,neighbor,dd,RR,ZZ);

if showresults==1,
  figure(1);
  fullfig
  scatter3(XX(1,:),XX(2,:),XX(3,:),3,cc(:)');
  hold on;
  plotmfa3(LX,MX,PX,{'linewidth',2,'color',[0 0 0]});
  hold off
  %rotatecamera

  figure(2);
  scatter(YY(1,:),YY(2,:),3,cc(:)');
  hold on
  plotmfa2(LY,MY,[0;0],{'linewidth',2,'color',[0 0 0]},[]);
  hold off
end;
