
function Vup

pos = get(0, 'PointerLocation');
[thisf,thisfig] = gcbo;

uu=get(thisf,'UserData');

currunits = get(thisf, 'Units');
set(thisf, 'Units', 'pixels');
FigPos = get(thisf, 'Position');

pos = pos - FigPos(1:2);
pos = pos ./ FigPos(3:4);


moveax = [];
apos = get(uu.aa, 'Position'); 
if pos(1) >= apos(1) & pos(2) >= apos(2) & ...
      pos(1) <= apos(1)+apos(3) & pos(2) <= apos(2)+apos(4),
   moveax = uu.aa;
end

if (isempty(moveax)  |  ~ishandle(moveax))
  set(thisf,'Pointer','arrow');
  return;
end;

apos = get(moveax, 'Position');
pos = pos - apos(1:2);
pos = pos ./ apos(3:4);
xlim = get(moveax, 'XLim');
ylim = get(moveax, 'YLim');
pos(1) = pos(1)*(xlim(2)-xlim(1))+xlim(1);
pos(2) = pos(2)*(ylim(2)-ylim(1))+ylim(1);

set(thisf,'Pointer','crosshair');

set(thisf, 'Units', currunits);

uu.buttondown = 0;
uu.pathlen = uu.pathlen+1;
uu.path(:,uu.pathlen) = pos(:);
uu.path = uu.path(:,1:uu.pathlen);

for nn=1:length(uu.curveviewers),
  feval(uu.curveviewers{nn}.dispfn,uu.path,uu.curveviewers{nn}.P);
end;
for nn=1:length(uu.lineviewers),
  feval(uu.lineviewers{nn}.dispfn,uu.path(:,1),uu.path(:,end),...
        uu.lineviewers{nn}.P);
end;

uu.path = [];
uu.pathlen = 0;

set(thisf,'userdata',uu);
