
if isempty(who('redo')), redo=2; end;
if isempty(who('showresults')), showresults=1; end;

i = (0:.01:2*pi);
XX = [cos(i); sin(i)];
XX = XX + .01*randn(2,length(i));
n = length(i);
XX = [XX XX+1 XX+[.5*ones(1,n); -.5*ones(1,n)]];
clear i n

NN = size(XX,2);
DD = 2;
KK = 30;
FF = 1;
nn = 10;
dd = 2;

if redo>1,
  [LX,MX,PX,Pi]=mppca(XX,FF,KK,1e-10,200,1e-3);
  redo=1;
end;

if redo>0,
  [RR,ZZ] = infermfa(XX,LX,MX,PX,Pi);
  neighbor = knn(XX,nn);
  redo=0;
end;

[YY LY MY] = llc(XX,neighbor,dd,RR,ZZ);

if showresults==1,
  figure(1);
  subplot(121);
  plot(XX(1,:),XX(2,:),'.');
  plotmfa2(LX,MX,PX);

  subplot(122);
  plot(YY(1,:),YY(2,:),'.');
  plotmfa2(LY,MY,1e-3*[1;1]);
end;
